/*
  Copyright 2007 Takashi Oguma

  This file is part of SendToCMD.

  SendToCMD is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  SendToCMD is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SendToCMD; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#pragma once

// Windows headers
#include <shlobj.h>

// private headers
#include "Uncopyable.h"


namespace bearmini
{
    template<typename T>
    class ScopedComObjectPointer : private Uncopyable
    {
    public:
        ScopedComObjectPointer() : pComObject(0)
        {
        }

        ~ScopedComObjectPointer()
        {
            pComObject->Release();
        }
        
        T** operator &()
        {
            return &pComObject;
        }

        T* operator ->()
        {
            return pComObject;
        }

    private:
        T* pComObject;
    };

}
